<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Manage Files</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Configuration Management</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="7">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/index.html">Introduction</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/functions.html">Functions</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/pillar.html">Pillar</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/include.html">Includes</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/requisites.html">Ordering & Requisites</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/jinja.html">Jinja</a>
                </li>
                
                
                
                <li class="progtrckr-done">Manage Files</li>
                
                
                
                
                
                
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Manage Files</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Deliver files and folders to manages systems</li>
                    
                    <li class="progtrckr-done">Understand Salt file templates</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <div class="section sidebar">
<h4 id="file-templates">File Templates</h4>
<p>Salt lets you manage files using templates and variables. Take a look at the <a href="https://docs.saltstack.com/en/latest/ref/states/all/salt.states.file.html">salt.states.file docs</a> to learn more.</p>
<h4 id="git-fileserver">Git Fileserver</h4>
<p>Many organizations store all of their configuration and resource files under source control for change tracking. Salt lets you use a Git repo as the file server instead of (or in addition to) the local file system on your Salt master to greatly simplify this workflow.</p>
<p>For example, if your <code>http.conf</code> is sourced in a Git repo, each time a change is committed all targeted systems would receive the change the next time the <code>file.managed</code> Salt state runs.</p>
<p>See the <a href="https://docs.saltstack.com/en/latest/topics/tutorials/gitfs.html#git-fileserver-backend-walkthrough">Git Fileserver Backend Walkthrough</a> to learn how to set up your own Git repo as a Salt file server backend.</p>
</div>
<p>Getting the correct files on a system is often more challenging than installing the correct software. Salt has a built-in file server that can deliver files and folders to managed systems.</p>
<h2 id="salt">salt://</h2>
<p>You are familiar with placing Salt state files in the <code>srv/salt</code> directory, but what you might not know is that any other files and folders you place in this directory are also available to your Salt minions. You can reference these files in Salt states using the <code>salt://</code> URL followed by the path to the file relative to the <code>srv/salt</code> directory.</p>
<h2 id="file.managed">File.Managed</h2>
<p>This Salt state function lets you manage a local file by specifying the source file on the Salt master.</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">deploy the http.conf file:</span>
  <span class="fu">file.managed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> /etc/http/conf/http.conf
    <span class="kw">-</span> <span class="fu">source:</span> salt://apache/http.conf</code></pre>
<p>Since the <code>source</code> path starts with <code>salt://</code>, we can determine that the source for this file is <code>/srv/salt/apache/http.conf</code> on our Salt master.</p>
<p>Each time this Salt state is applied, Salt makes sure that the local file matches the version on the server. This helps prevent configuration drift and helps make sure that applications are configured identically on different systems.</p>
<p>For example, if you want to distribute a global configuration file for <code>lftp</code> that includes a custom setting that limits download rates, we can do this using <code>file.managed</code>:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">install network packages:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">pkgs:</span>
      <span class="kw">-</span> rsync
      <span class="kw">-</span> lftp
      <span class="kw">-</span> curl

<span class="fu">copy lftp config file:</span>
  <span class="fu">file.managed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> /etc/lftp.conf
    <span class="kw">-</span> <span class="fu">source:</span> salt://_tmpl_lftp.conf</code></pre>
<p>Another option, since our configuration change is a single line, is to use <code>file.append</code> to simply insert the new line we want to add:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">install network packages:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">pkgs:</span>
      <span class="kw">-</span> rsync
      <span class="kw">-</span> lftp
      <span class="kw">-</span> curl

<span class="fu">update lftp conf:</span>
  <span class="fu">file.append:</span>
    <span class="kw">-</span> <span class="fu">name:</span> /etc/lftp.conf
    <span class="kw">-</span> <span class="fu">text:</span> set net:limit-rate 100000:500000</code></pre>
<h2 id="file.recurse">File.Recurse</h2>
<p>This Salt state function copies an entire directory.</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">copy some files to the web server:</span>
  <span class="fu">file.recurse:</span>
    <span class="kw">-</span> <span class="fu">name:</span> /var/www
    <span class="kw">-</span> <span class="fu">source:</span> salt://apache/www</code></pre>
<h2 id="summary">Summary</h2>
<p>You should now have a better understanding of SaltStack’s configuration management system, with enough knowledge to start writing your own Salt states. If you are looking for inspiration, the <a href="https://github.com/saltstack-formulas">SaltStack Formula Repo</a> contains many examples.</p>


            <br>
            
            <a href="/en/getstarted/config/jinja.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/../index.html">
                <button type="button" class="btn btn-primary btn-right">
                    <span class="glyphicon glyphicon-chevron-left"></span> Back to Get Started
                </button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>